import 'package:analyzer/dart/analysis/analysis_context.dart';
import 'package:analyzer/dart/analysis/analysis_context_collection.dart';
import 'package:report/parser/report.dart';
import 'analyze_file.dart';
import 'package:report/parser/bloc_path.dart';

Future<void> main(List<String> arguments) async {
  // CommandRunner runner = CommandRunner('config', 'Config widget Analyze Tools.')..addCommand(CreateCommand());
  // await runner.run(arguments);
  runAnalyze(rootPath: '/Users/dansun/Documents/github/report');
}

Future<void> runAnalyze({String rootPath, String reportPath = '/Users/dansun/Documents/github/report/lib/analyze/report.json'}) async {
  List<String> includedPaths = await packagePath(rootPath);
  print('正在分析中。。。。 ${includedPaths.length} ');
  Map<String, dynamic> reportMap = await reportJson(reportPath);
  if (reportMap == null) {
    return null;
  }
  ReportData reportData = ReportData(reportMap);
  DateTime begin = DateTime.now();
  // ignore: avoid_print
  print('正在分析中。。。。 ');
  AnalysisContextCollection collection = AnalysisContextCollection(includedPaths: includedPaths);
  for (final String path in includedPaths) {
    AnalysisContext context = collection.contextFor(path);
    await analyzeSingleFile(context, path, reportData);
  }

  // // ignore: avoid_print
  print('完成用时 ${DateTime.now().difference(begin)}');
}
