import 'package:analyzer/dart/ast/ast.dart';
import 'package:analyzer/dart/ast/visitor.dart';
import 'package:_fe_analyzer_shared/src/scanner/token.dart';
import 'property_path.dart';

//访问的是
/* ReturnStatementImpl
 * ---InstanceCreationExpressionImpl ---
 * ------ConstructorNameImpl
 * ------ArgumentListImpl
 * ---------NamedExpressionImpl
 * ---------NamedExpressionImpl
 */

class ConstructorVisit extends RecursiveAstVisitor<void> {
  ConstructorVisit() {
    list = [];
  }
  List<Constructor> list;

  @override
  void visitConstructorName(ConstructorName node) {
    var parent = node.parent;

    parent.childEntities.forEach((entry) {
      if (entry is ArgumentList) {
        for (Expression expression in entry.arguments) {
          /// uuid : 'string'
          if (expression.beginToken.toString() == 'uuid' &&
              expression.beginToken.next.type == TokenType.COLON &&
              expression.endToken.type == TokenType.STRING) {
            ;
            NamedExpressionVisit namedExpressionVisit = NamedExpressionVisit();
            entry.visitChildren(namedExpressionVisit);
            if (namedExpressionVisit.property.uuidPosition != null) {
              Token previous = parent.beginToken.runtimeType == KeywordToken ? parent.beginToken.previous : parent.beginToken;
              // print('previous $previous ${previous.type}  ${previous.runtimeType}');
              // print('beginToken ${parent.beginToken} ');
              list.add(Constructor()
                ..property = namedExpressionVisit.property
                ..constructorBegin = previous);
            }
          }
        }
      }
    });
    return;
  }
}

class NamedExpressionVisit extends RecursiveAstVisitor<void> {
  Property property;
  NamedExpressionVisit() {
    property = Property();
  }
  @override
  void visitNamedExpression(NamedExpression node) {
    if (node.beginToken.toString() == 'uuid') {
      property.uuidPosition = PropertyPosition(node.beginToken, node.endToken);
    }
    if (node.beginToken.toString() == 'name') {
      property.namePosition = PropertyPosition(node.beginToken, node.endToken);
    }
  }
}
