// import 'package:analyzer/dart/analysis/analysis_context.dart';
//
// import 'package:analyzer/dart/analysis/results.dart';
// import 'package:analyzer/dart/analysis/session.dart';
// import 'package:analyzer/dart/ast/ast.dart';
// import 'package:analyzer/dart/ast/visitor.dart';
// import 'package:_fe_analyzer_shared/src/parser/parser.dart';
// import 'package:_fe_analyzer_shared/src/scanner/token.dart';
// import 'package:_fe_analyzer_shared/src/scanner/recover.dart';
//
// class DebugListener extends Listener {}
//
// Future<PropertyPath> analyzeSingleFile(AnalysisContext context, String path) async {
//   AnalysisSession session = context.currentSession;
//   ResolvedUnitResult resultA = await session.getResolvedUnit(path);
//
//   CompilationUnit unit = resultA.unit; //AST 的根结点
//   PropertyPath propertyPath;
//
//   for (final CompilationUnitMember unitMember in unit.declarations) {
//     if (unitMember is ClassDeclaration) {
//       ConstructorVisit constructorVisit = ConstructorVisit();
//       unitMember.visitChildren(constructorVisit);
//       if (constructorVisit.list.isNotEmpty) {
//         printTokens(unit.beginToken);
//         print('=== ${resultA.content}');
//         propertyPath = PropertyPath(path: path, list: constructorVisit.list);
//         // Parser parser = Parser(DebugListener());
//         // parser.rewriter.insertParens(token, false);
//       }
//     }
//   }
//   return propertyPath;
// }
//
// //访问的是
// /* ReturnStatementImpl
//  * ---InstanceCreationExpressionImpl ---
//  * ------ConstructorNameImpl
//  * ------ArgumentListImpl
//  * ---------NamedExpressionImpl
//  * ---------NamedExpressionImpl
//  */
//
// class ConstructorVisit extends RecursiveAstVisitor<void> {
//   ConstructorVisit() {
//     list = [];
//   }
//   List<Property> list;
//   Token begin;
//
//   @override
//   void visitConstructorName(ConstructorName node) {
//     var parent = node.parent;
//     begin = node.root.beginToken;
//     parent.childEntities.forEach((entry) {
//       if (entry is ArgumentList) {
//         for (Expression expression in entry.arguments) {
//           if (expression.beginToken.toString() == 'uuid') {
//             NamedExpressionVisit namedExpressionVisit = NamedExpressionVisit();
//             entry.visitChildren(namedExpressionVisit);
//             if (namedExpressionVisit.property.uuidPosition != null) {
//               list.add(namedExpressionVisit.property);
//             }
//           }
//         }
//       }
//     });
//     return;
//   }
// }
//
// class NamedExpressionVisit extends RecursiveAstVisitor<void> {
//   Property property;
//   NamedExpressionVisit() {
//     property = Property();
//   }
//   @override
//   void visitNamedExpression(NamedExpression node) {
//     if (node.beginToken.toString() == 'uuid') {
//       property.uuidPosition = PropertyPosition(node.beginToken, node.endToken);
//     }
//     if (node.beginToken.toString() == 'name') {
//       print('node end ${node.endToken.runtimeType}');
//       print('node end ${node.endToken.type}');
//       Parser parser = Parser(DebugListener());
//       Token token = synthesizeToken(node.endToken.offset, '\'dsddd\'', TokenType.STRING);
//
//       Token token1 = parser.rewriter.replaceTokenFollowing(node.endToken.previous, token);
//       property.namePosition = PropertyPosition(node.beginToken, node.endToken);
//     }
//   }
// }
//
// void printTokens(Token token) {
//   StringBuffer a = StringBuffer();
//   while (!token.isEof) {
//     print("${token.charOffset}: $token");
//     a.write(' $token');
//     token = token.next;
//   }
//   print('== ${a.toString()}');
// }
//
// class PropertyPosition {
//   final Token beginToken;
//   final Token endToken;
//
//   PropertyPosition(this.beginToken, this.endToken);
//
//   @override
//   String toString() {
//     return 'PropertyPosition{beginToken: $beginToken beginToken charOffset ${beginToken.charOffset} beginToken charEnd ${beginToken.charEnd}, endToken: $endToken} endToken charOffset ${endToken.charOffset} endToken charEnd ${endToken.charEnd}';
//   }
// }
//
// class Property {
//   PropertyPosition uuidPosition;
//   PropertyPosition namePosition;
//
//   Property();
//
//   @override
//   String toString() {
//     return 'Property{uuidPosition: $uuidPosition, namePosition: $namePosition}';
//   }
// }
//
// class PropertyPath {
//   final String path;
//   final List<Property> list;
//
//   PropertyPath({this.path, this.list});
//
//   @override
//   String toString() {
//     return 'PropertyPath{path: $path, list: $list}';
//   }
// }
